#include <bnb/glsl.frag>

layout( location = 1 ) out vec4 G;
layout( location = 2 ) out vec4 B;

BNB_IN(0) vec2 var_uv;
BNB_IN(1) float step_x;



BNB_DECLARE_SAMPLER_2D(0, 1, bg_masked);


const int KERNEL_RADIUS = 8;

void main()
{
	vec4 kernel[9];
	kernel[8] = vec4(0.014096,-0.022658, 0.000115,0.009116);
	kernel[7] = vec4(-0.020612,-0.025574,0.005324,0.013416);
	kernel[6] = vec4(-0.038708,0.006957, 0.013753,0.016519);
	kernel[5] = vec4(-0.021449,0.040468, 0.024700,0.017215);
	kernel[4] = vec4(0.013015,0.050223,  0.036693,0.015064);
	kernel[3] = vec4(0.042178,0.038585,  0.047976,0.010684);
	kernel[2] = vec4(0.057972,0.019812,  0.057015,0.005570);
	kernel[1] = vec4(0.063647,0.005252,  0.062782,0.001529);
	kernel[0] = vec4(0.064754,0.000000,  0.064754,0.000000);
	vec4 valbnb_FragColor = vec4(0.);
	vec4 valG = vec4(0.);
	vec4 valB = vec4(0.);

	for( int i = -KERNEL_RADIUS; i <= KERNEL_RADIUS; ++i )
	{
		vec2 uv = var_uv;
		uv.x + step_x*float(i);
		vec3 img_pixel = BNB_TEXTURE_2D(BNB_SAMPLER_2D(bg_masked),uv).xyz;
		vec4 k = kernel[abs(i)];
		valbnb_FragColor += img_pixel.r*k;
		valG += img_pixel.g*k;
		valB += img_pixel.b*k;
	}

	bnb_FragColor = valbnb_FragColor;
	G = valG;
	B = valB;
}
